
#pragma hdrstop
#include <condefs.h>
#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <conio.h>
#include <stdlib.h>

//---------------------------------------------------------------------------
class BeispielKlasse
{
   public:
      void setx(int px) { nx = px; }
      void sety(int py) { ny = py; }
      int  getx(void)   { return nx; }
      int  gety(void)   { return ny; }

      friend ostream  & operator<< (ostream  & os,  const BeispielKlasse & bsp);
      friend istream  & operator>> (istream  & is,  BeispielKlasse & bsp);
      friend ofstream & operator<< (ofstream & ofs, const BeispielKlasse & bsp);
      friend ifstream & operator>> (ifstream & ifs, BeispielKlasse & bsp);

      void save (ofstream & ofs);
      void load (ifstream & ifs);

   private:
      int nx;
      int ny;
};

//---------------------------------------------------------------------------
// Ausgabe auf Bildschrim
ostream & operator<< (ostream & os, const BeispielKlasse & bsp)
{
   os << bsp.nx << ", " << bsp.ny;
   return os;
}

//---------------------------------------------------------------------------
// Eingabe von der Tastatur
istream & operator>> (istream & is, BeispielKlasse & bsp)
{
   is >> bsp.nx >> bsp.ny;
   return is;
}

//---------------------------------------------------------------------------
// speichern als CSV-Datei
ofstream & operator<< (ofstream & ofs, const BeispielKlasse & bsp)
{
   ofs << setw(10) << bsp.nx << ";" << setw(10) << bsp.ny;
   return ofs;
}

//---------------------------------------------------------------------------
// laden als CSV-Datei
ifstream & operator>> (ifstream & ifs, BeispielKlasse & bsp)
{
   char  sLesen[1000] = "";      // Zeilenpuffer
   char *pHelp       = NULL;     // Hilfspointer

   ifs.getline(sLesen, 1000);    // Eine Zeile aus der Datei einlesen
   pHelp = strchr (sLesen, ';'); // nach Trennzeichen suchen
   if (pHelp)                    // Wenn Trennzeichen gefunden
   {
     *pHelp = '\0';              // Trennzeichen durch Zeilenende ersetzen
     pHelp++;                    // Hilfszeiger als zweiten String nutzen
   }

   bsp.nx = atoi(sLesen);        // Zeichenkette in Zahl wandeln
   bsp.ny = atoi(pHelp);         // Zeichenkette in Zahl wandeln

   return ifs;
}

//---------------------------------------------------------------------------
void BeispielKlasse::save (ofstream & ofs)
{
   ofs << (*this) << endl;
}

//---------------------------------------------------------------------------
void BeispielKlasse::load (ifstream & ifs)
{
   ifs >> (*this);
}

//---------------------------------------------------------------------------
#pragma argsused
void main(void)
{
   BeispielKlasse test1;
   test1.setx(11);
   test1.sety(22);

   BeispielKlasse test2;
   test2.setx(33);
   test2.sety(44);

   cout << test1 << endl;
   cout << test2 << endl;

   // Ausgabemglichkeit 1 --------------------------------------------------
   ofstream Ausgabe1 ("e:\\Ausgabe1.txt");
   test1.save(Ausgabe1);
   test2.save(Ausgabe1);
   Ausgabe1.close();

   // Ausgabemglichkeit 2 --------------------------------------------------
   ofstream Ausgabe2 ("e:\\Ausgabe2.txt");
   Ausgabe2 << test1 << endl;
   Ausgabe2 << test2 << endl;
   Ausgabe2.close();

   BeispielKlasse test3;
   test3.setx(0);
   test3.sety(0);

   BeispielKlasse test4;
   test4.setx(0);
   test4.sety(0);

   cout << test3 << endl;
   cout << test4 << endl;

   // Einlesemglichkeit 1 --------------------------------------------------
   ifstream Eingabe1 ("e:\\Ausgabe1.txt");
   test3.load(Eingabe1);
   test4.load(Eingabe1);
   Eingabe1.close();

   cout << test3 << endl;
   cout << test4 << endl;

   test3.setx(0);
   test3.sety(0);

   test4.setx(0);
   test4.sety(0);

   cout << test3 << endl;
   cout << test4 << endl;

   // Einlesemglichkeit 2 --------------------------------------------------
   ifstream Eingabe2 ("e:\\Ausgabe2.txt");
   Eingabe2 >> test3;
   Eingabe2 >> test4;
   Eingabe2.close();

   cout << test3 << endl;
   cout << test4 << endl;

   getch();
}
